.\" Copyright (c) 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	From: @(#)sysctl.8	8.1 (Berkeley) 6/6/93
.\" $FreeBSD: src/usr.sbin/sysctl/sysctl.8,v 1.10.2.4 1999/09/05 11:41:23 peter Exp $
.\"
.Dd September 23, 1994
.Dt SYSCTL 8
.Os
.Sh NAME
.Nm sysctl
.Nd get or set kernel state
.Sh SYNOPSIS
.Nm sysctl
.Op Fl bn
.Ar name ...
.Nm sysctl
.Op Fl bn
.Fl w
.Ar name=value ...
.Nm sysctl
.Op Fl bn
.Fl aAX
.Sh DESCRIPTION
The
.Nm
utility retrieves kernel state and allows processes with
appropriate privilege to set kernel state.
The state to be retrieved or set is described using a
``Management Information Base'' (``MIB'') style name,
described as a dotted set of components.
.Pp
The following options are available:
.Bl -tag -width indent
.It Fl a
List all the currently available string or integer values.
.It Fl A
List all the known MIB names including opaques.
Those with string or integer values will be printed as with the
.Fl a
flag; for the opaque values,
information about the format and the length is printed in addition the first
few bytes is dumped in hex.
.It Fl X 
Same as
.Fl A
except the entire value of opaque variables is hexdumped.
.It Fl n
Specify that the printing of the field name should be
suppressed and that only its value should be output.
This flag is useful for setting shell variables.
For example, to save the pagesize in variable psize, use:
.Bd -literal -offset indent -compact
set psize=`sysctl -n hw.pagesize`
.Ed
.It Fl b
Force the value of the variable(s) to be output in raw, binary
format.  No names are printed and no terminating newlines are output.
This is mostly useful with a single variable.
.It Fl w Ar name=value ...
Set the MIB
.Ar name
to the new
.Ar value .
If just a MIB style
.Ar name
is given,
the corresponding value is retrieved.
.El
.Pp
The information available from
.Nm
consists of integers, strings, and opaques.
.Nm Sysctl
only knows about a couple of opaque types, and will resort to hexdumps
for the rest.
The opaque information is much more useful if retrieved by special
purpose programs such as
.Nm ps ,
.Nm systat ,
and
.Nm netstat .
.Pp
The string and integer information is summarized below.
For a detailed description of these variable see
.Xr sysctl 3 .
.Pp
The changeable column indicates whether a process with appropriate
privilege can change the value.
.Bl -column net.inet.ip.forwardingxxxxxx integerxxx
.It Sy Name	Type	Changeable
.It kern.ostype	string	no
.It kern.osrelease	string	no
.It kern.osrevision	integer	no
.It kern.version	string	no
.It kern.maxvnodes	integer	yes
.It kern.maxproc	integer	no
.It kern.maxprocperuid	integer	yes
.It kern.maxfiles	integer	yes
.It kern.maxfilesperproc	integer	yes
.It kern.argmax	integer	no
.It kern.securelevel	integer	raise only
.It kern.hostname	string	yes
.It kern.hostid	integer	yes
.It kern.clockrate	struct	no
.It kern.posix1version	integer	no
.It kern.ngroups	integer	no
.It kern.job_control	integer	no
.It kern.saved_ids	integer	no
.It kern.boottime	struct	no
.It kern.domainname	string	yes
.It kern.update	integer	yes
.It kern.osreldate	string	no
.It kern.bootfile	string	yes
.It vm.loadavg	struct	no
.It hw.machine	string	no
.It hw.model	string	no
.It hw.ncpu	integer	no
.It hw.byteorder	integer	no
.It hw.physmem	integer	no
.It hw.usermem	integer	no
.It hw.pagesize	integer	no
.It hw.floatingpoint	integer	no
.It hw.machine_arch	string	no
.It machdep.console_device	dev_t	no
.It machdep.adjkerntz	integer	yes
.It machdep.disable_rtc_set	integer	yes
.It user.cs_path	string	no
.It user.bc_base_max	integer	no
.It user.bc_dim_max	integer	no
.It user.bc_scale_max	integer	no
.It user.bc_string_max	integer	no
.It user.coll_weights_max	integer	no
.It user.expr_nest_max	integer	no
.It user.line_max	integer	no
.It user.re_dup_max	integer	no
.It user.posix2_version	integer	no
.It user.posix2_c_bind	integer	no
.It user.posix2_c_dev	integer	no
.It user.posix2_char_term	integer	no
.It user.posix2_fort_dev	integer	no
.It user.posix2_fort_run	integer	no
.It user.posix2_localedef	integer	no
.It user.posix2_sw_dev	integer	no
.It user.posix2_upe	integer	no
.It user.stream_max	integer	no
.It user.tzname_max	integer	no
.El
.Sh EXAMPLES
For example, to retrieve the maximum number of processes allowed
in the system, one would use the follow request:
.Bd -literal -offset indent -compact
sysctl kern.maxproc
.Ed
.Pp
To set the maximum number of processes allowed
per uid to 1000, one would use the follow request:
.Bd -literal -offset indent -compact
sysctl -w kern.maxprocperuid=1000
.Ed
.Pp
Information about the system clock rate may be obtained with:
.Bd -literal -offset indent -compact
sysctl kern.clockrate
.Ed
.Pp
Information about the load average history may be obtained with:
.Bd -literal -offset indent -compact
sysctl vm.loadavg
.Ed
.Pp
More variables than these exist, and the best and likely only place 
to search for their deeper meaning is undoubtedly the source where
they are defined.
.Sh FILES
.Bl -tag -width <netinet/icmpXvar.h> -compact
.It Pa <sys/sysctl.h>
definitions for top level identifiers, second level kernel and hardware
identifiers, and user level identifiers
.It Pa <sys/socket.h>
definitions for second level network identifiers
.It Pa <sys/gmon.h>
definitions for third level profiling identifiers
.It Pa <vm/vm_param.h>
definitions for second level virtual memory identifiers
.It Pa <netinet/in.h>
definitions for third level Internet identifiers and
fourth level IP identifiers
.It Pa <netinet/icmp_var.h>
definitions for fourth level ICMP identifiers
.It Pa <netinet/udp_var.h>
definitions for fourth level UDP identifiers
.El
.Sh SEE ALSO
.Xr sysctl 3
.Sh BUGS
.Nm Sysctl
presently exploits an undocumented interface to the kernel
sysctl facility to traverse the sysctl tree and to retrieve format 
and name information. 
This correct interface is being thought about for the time being.
.Sh HISTORY
.Nm Sysctl
first appeared in
.Bx 4.4 .
.Pp
In 
.Fx 2.2 ,
.Nm
was significantly remodeled.
